##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))


PALETTE=0 1 2 3 6 7 9 10 11 12 13 15 25 16 23 26

$(eval $(call IMG2SP, SET_FOLDER, src/lib/assets/sprites/ ))
$(eval $(call IMG2SP, SET_PALETTE_FW, $(PALETTE) ))
$(eval $(call IMG2SP, CONVERT, img/pelota.png, 8, 8, sp_pelota ))
$(eval $(call IMG2SP, CONVERT, img/JugadorSpriteSheet.png, 8, 16, sp_player_ ))
$(eval $(call IMG2SP, CONVERT, img/Enemigo1SpriteSheet.png, 8, 16, sp_enemigo1_ ))
$(eval $(call IMG2SP, CONVERT, img/Enemigo2SpriteSheet.png, 8, 16, sp_enemigo2_ ))
$(eval $(call IMG2SP, CONVERT, img/Enemigo3SpriteSheet.png, 8, 16, sp_enemigo3_ ))
$(eval $(call IMG2SP, SET_IMG_FORMAT, screen ))
$(eval $(call IMG2SP, CONVERT, img/escenarioBueno.png, 160, 200, bg_escenario ))
$(eval $(call IMG2SP, CONVERT, img/titulo.png, 160, 200, bg_principal ))