;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.globl entity_init
.globl entity_create
.globl entity_getArrayIX
.globl entity_getBallIY
.globl entity_getEnemyIX

;Constantes para tenerlo facil
entity_x = 1
entity_y = 0
entity_vx = 2
entity_vy = 3
entity_w = 4
entity_h = 5
entity_spriteL = 6 ;Ocupa 2, es pos de memoria
entity_spriteH = 7 ;y por eso lo guardamos en dos variables separadas para poder guardarlas como little endian
entity_type = 8 ; 0->Player, 1->Enemy, 2->Ball, 3->Player-Ball, 4->Enemy-Ball, 5->No Ball
entity_lastVP_l = 9
entity_lastVP_h = 10
entity_ball = 11
entity_points = 12
entity_anim_l = 13
entity_anim_h = 14
entity_anim_status = 15
;entity_array_anim_l = 16
;entity_array_anim_h = 17
sizeof_e = 16
max_entities= 3

nullptr = 0x0000

;.macro DefineComponentArrayStructure _Tname, _N, _DefineTypeMacroDefault
;    _Tname'_num: .db 0
;    _Tname'_pend: .dw _Tname'_array
;    _Tname'_array:
;        .rept _N
;            _DefineTypeMacroDefault
;        .endm
;.endm

.macro ld__ixh_d
    .db #0xDD
    .db #52
.endm

.macro ld__ixl_e
    .db #0xDD
    .db #0x6B
.endm

.macro add_REGPAIR_a rh, rl
    ;; First Perform RH = E + A
    add rl    ;; [1] A' = RL + A 
    ld  rl, a ;; [1] RL' = A' = RL + A. It might generate Carry that must be added to RH    
    ;; Then Perform RH = RH + Carry 
    adc rh    ;; [1] A'' = A' + RH + Carry = RL + A + RH + Carry
    sub rl    ;; [1] Remove RL'. A''' = A'' - RL' = RL + A + RH + Carry - (RL + A) = RH + Carry
    ld  rh, a ;; [1] Save into RH (RH' = A''' = RH + Carry)
.endm
.macro add_hl_a
    add_REGPAIR_a  h, l
.endm

;Llena de ceros y genera las variables
.macro DefineComponentArrayStructure _Tname, _N, _ComponentSize
    _Tname'_num: .db 0
    _Tname'_pend: .dw _Tname'_array
    _Tname'_array:
        .ds _N * _ComponentSize
.endm

;Para cargar el sprite es menos complicado con un .dw
.macro CreateEntity _x, _y, _vx, _vy, _w, _h, _sprite, _type, _vPointer, _ball, _points, _animptr  ;_arrayAnimPtr
    .db _x
    .db _y
    .db _vx
    .db _vy
    .db _w
    .db _h
    .dw _sprite ;Dado que es una direccion
    .db _type
    .dw _vPointer
    .db _ball
    .db _points
    .dw _animptr
    .db 0x00
    ;.dw _arrayAnimPtr
.endm

.macro ReproducirAnimacion _sprite1, _sprite2, _sprite3, _funcion
    .dw _sprite1
    .dw _sprite2
    .dw _sprite3
    .dw nullptr
    .dw _funcion
.endm



