;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "lib/assets/assets.h.s"
.include "lib/man/entity.h.s"

.module animations

_animations_array::
    .dw _player_quieto
    .dw _player_andando_derecha
    .dw _player_andando_izda
    .dw nullptr
    .dw _player_andando_Abajo
    .dw _player_andando_Abdrcha
    .dw _player_andando_Abizda
    .dw nullptr
    .dw _player_andando_Arriba
    .dw _player_andando_Ardrcha
    .dw _player_andando_Arizda 
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw _enemigo_quieto
    .dw _enemigo_andando_derecha
    .dw _enemigo_andando_izda
    .dw nullptr
    .dw _enemigo_andando_Abajo
    .dw _enemigo_andando_Abderecha
    .dw _enemigo_andando_Abizda
    .dw nullptr
    .dw _enemigo_andando_Arriba
    .dw _enemigo_andando_Arderecha
    .dw _enemigo_andando_Arizda

_animations_array2::
    .dw _player_quieto
    .dw _player_andando_derecha
    .dw _player_andando_izda
    .dw nullptr
    .dw _player_andando_Abajo
    .dw _player_andando_Abdrcha
    .dw _player_andando_Abizda
    .dw nullptr
    .dw _player_andando_Arriba
    .dw _player_andando_Ardrcha
    .dw _player_andando_Arizda 
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw _enemigo2_quieto
    .dw _enemigo2_andando_derecha
    .dw _enemigo2_andando_izda
    .dw nullptr
    .dw _enemigo2_andando_Abajo
    .dw _enemigo2_andando_Abderecha
    .dw _enemigo2_andando_Abizda
    .dw nullptr
    .dw _enemigo2_andando_Arriba
    .dw _enemigo2_andando_Arderecha
    .dw _enemigo2_andando_Arizda

_animations_array3::
    .dw _player_quieto
    .dw _player_andando_derecha
    .dw _player_andando_izda
    .dw nullptr
    .dw _player_andando_Abajo
    .dw _player_andando_Abdrcha
    .dw _player_andando_Abizda
    .dw nullptr
    .dw _player_andando_Arriba
    .dw _player_andando_Ardrcha
    .dw _player_andando_Arizda 
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw nullptr
    .dw _enemigo3_quieto
    .dw _enemigo3_andando_derecha
    .dw _enemigo3_andando_izda
    .dw nullptr
    .dw _enemigo3_andando_Abajo
    .dw _enemigo3_andando_Abderecha
    .dw _enemigo3_andando_Abizda
    .dw nullptr
    .dw _enemigo3_andando_Arriba
    .dw _enemigo3_andando_Arderecha
    .dw _enemigo3_andando_Arizda



man_animationHL::
    ld a, entity_points(iy)
    _lvl0:
        cp a, #0x00
        jr z, _doIt_1
    _lvl1:
        ;ld a, entity_ball(iy)
        cp a, #0x01
        jr z, _doIt_2
    _lvl2:
        ;ld a, entity_ball(iy)
        cp a, #0x02
        jr z, _doIt_3
    _doIt_1:
        ld hl, #_animations_array
        ;ld hl, entity_array_anim_l(ix) 
        ;ld h, entity_array_anim_h(ix)
        jp _nextStep
    _doIt_2:
        ld hl, #_animations_array2
        ;ld hl, entity_array_anim_l(ix) 
        ;ld h, entity_array_anim_h(ix)
        jp _nextStep
    _doIt_3:
        ld hl, #_animations_array3
        ;ld hl, entity_array_anim_l(ix) 
        ;ld h, entity_array_anim_h(ix)
        jp _nextStep
     _nextStep:
        ld a, b
        add a
        add_hl_a

        ld a, (hl)
        inc hl
        ld h, (hl)
        ld l, a   
    ret

;; HACIA LA DERECHA

_player_quieto::
    .dw _sp_player__00
    .dw nullptr
    .dw _player_quieto
_player_andando_derecha:: ReproducirAnimacion _sp_player__19, _sp_player__20, _sp_player__21, _player_andando_derecha
_player_andando_izda:: ReproducirAnimacion, _sp_player__22, _sp_player__23, _sp_player__24, _player_andando_izda
_player_andando_Arriba:: ReproducirAnimacion, _sp_player__10, _sp_player__11, _sp_player__12, _player_andando_Arriba
_player_andando_Ardrcha:: ReproducirAnimacion, _sp_player__13, _sp_player__14, _sp_player__15, _player_andando_Ardrcha
_player_andando_Arizda:: ReproducirAnimacion, _sp_player__16, _sp_player__17, _sp_player__18, _player_andando_Arizda
_player_andando_Abajo:: ReproducirAnimacion, _sp_player__01, _sp_player__02, _sp_player__03, _player_andando_Abajo
_player_andando_Abdrcha:: ReproducirAnimacion, _sp_player__04, _sp_player__05, _sp_player__06, _player_andando_Abdrcha
_player_andando_Abizda:: ReproducirAnimacion, _sp_player__07, _sp_player__08, _sp_player__09, _player_andando_Abizda

_enemigo_quieto::
    .dw _sp_enemigo1__00
    .dw nullptr
    .dw _enemigo_quieto
_enemigo_andando_derecha:: ReproducirAnimacion _sp_enemigo1__19, _sp_enemigo1__20, _sp_enemigo1__21, _enemigo_andando_derecha
_enemigo_andando_izda:: ReproducirAnimacion, _sp_enemigo1__22, _sp_enemigo1__23, _sp_enemigo1__24, _enemigo_andando_izda
_enemigo_andando_Arriba:: ReproducirAnimacion, _sp_enemigo1__10, _sp_enemigo1__11, _sp_enemigo1__12, _enemigo_andando_Arriba
_enemigo_andando_Arderecha:: ReproducirAnimacion, _sp_enemigo1__13, _sp_enemigo1__14, _sp_enemigo1__15, _enemigo_andando_Arderecha
_enemigo_andando_Arizda:: ReproducirAnimacion, _sp_enemigo1__16, _sp_enemigo1__17, _sp_enemigo1__18, _enemigo_andando_Arizda
_enemigo_andando_Abajo:: ReproducirAnimacion, _sp_enemigo1__01, _sp_enemigo1__02, _sp_enemigo1__03, _enemigo_andando_Abajo
_enemigo_andando_Abderecha:: ReproducirAnimacion, _sp_enemigo1__04, _sp_enemigo1__05, _sp_enemigo1__06, _enemigo_andando_Abderecha
_enemigo_andando_Abizda:: ReproducirAnimacion, _sp_enemigo1__07, _sp_enemigo1__08, _sp_enemigo1__09, _enemigo_andando_Abizda

_enemigo2_quieto::
    .dw _sp_enemigo2__00
    .dw nullptr
    .dw _enemigo2_quieto
_enemigo2_andando_derecha:: ReproducirAnimacion _sp_enemigo2__19, _sp_enemigo2__20, _sp_enemigo2__21, _enemigo2_andando_derecha
_enemigo2_andando_izda:: ReproducirAnimacion, _sp_enemigo2__22, _sp_enemigo2__23, _sp_enemigo2__24, _enemigo2_andando_izda
_enemigo2_andando_Arriba:: ReproducirAnimacion, _sp_enemigo2__10, _sp_enemigo2__11, _sp_enemigo2__12, _enemigo2_andando_Arriba
_enemigo2_andando_Arderecha:: ReproducirAnimacion, _sp_enemigo2__13, _sp_enemigo2__14, _sp_enemigo2__15, _enemigo2_andando_Arderecha
_enemigo2_andando_Arizda:: ReproducirAnimacion, _sp_enemigo2__16, _sp_enemigo2__17, _sp_enemigo2__18, _enemigo2_andando_Arizda
_enemigo2_andando_Abajo:: ReproducirAnimacion, _sp_enemigo2__01, _sp_enemigo2__02, _sp_enemigo2__03, _enemigo2_andando_Abajo
_enemigo2_andando_Abderecha:: ReproducirAnimacion, _sp_enemigo2__04, _sp_enemigo2__05, _sp_enemigo2__06, _enemigo2_andando_Abderecha
_enemigo2_andando_Abizda:: ReproducirAnimacion, _sp_enemigo2__07, _sp_enemigo2__08, _sp_enemigo2__09, _enemigo2_andando_Abizda

_enemigo3_quieto::
    .dw _sp_enemigo3__00
    .dw nullptr
    .dw _enemigo3_quieto
_enemigo3_andando_derecha:: ReproducirAnimacion _sp_enemigo3__19, _sp_enemigo3__20, _sp_enemigo3__21, _enemigo3_andando_derecha
_enemigo3_andando_izda:: ReproducirAnimacion, _sp_enemigo3__22, _sp_enemigo3__23, _sp_enemigo3__24, _enemigo3_andando_izda
_enemigo3_andando_Arriba:: ReproducirAnimacion, _sp_enemigo3__10, _sp_enemigo3__11, _sp_enemigo3__12, _enemigo3_andando_Arriba
_enemigo3_andando_Arderecha:: ReproducirAnimacion, _sp_enemigo3__13, _sp_enemigo3__14, _sp_enemigo3__15, _enemigo3_andando_Arderecha
_enemigo3_andando_Arizda:: ReproducirAnimacion, _sp_enemigo3__16, _sp_enemigo3__17, _sp_enemigo3__18, _enemigo3_andando_Arizda
_enemigo3_andando_Abajo:: ReproducirAnimacion, _sp_enemigo3__01, _sp_enemigo3__02, _sp_enemigo3__03, _enemigo3_andando_Abajo
_enemigo3_andando_Abderecha:: ReproducirAnimacion, _sp_enemigo3__04, _sp_enemigo3__05, _sp_enemigo3__06, _enemigo3_andando_Abderecha
_enemigo3_andando_Abizda:: ReproducirAnimacion, _sp_enemigo3__07, _sp_enemigo3__08, _sp_enemigo3__09, _enemigo3_andando_Abizda