;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "lib/man/entity.h.s"
.include "lib/man/game.h.s"
.include "lib/sys/input.h.s"
.include "lib/sys/physics.h.s"
.include "lib/sys/render.h.s"
.include "lib/assets/assets.h.s"
.include "lib/sys/collision.h.s"
.include "lib/sys/grab.h.s"
.include "lib/sys/puntuacion.h.s"
.include "lib/sys/animation.h.s"
.include "lib/man/animations.h.s"

.module game

;Aqui se ponen esta y las demas entidades que hagan falta
player: CreateEntity 0xA4, 0x24, 0, 0, 4, 0x10, _sp_player__00, 0x00, 0xE537, 0x00, 0x00, _player_quieto 
enemy:  CreateEntity 0x11, 0x24, 1, 2, 4, 0x10, _sp_enemigo1__00, 0x01, 0xE537, 0x00, 0x00, _enemigo_quieto 
ball:   CreateEntity 0x60, 0x26, 0, 1, 4, 8, _sp_pelota, 0x02, 0xE537, 0x15, 0x00, nullptr 
;Tipo de pelota: 2 suelta, 3 agarrada
;Ball var en player o enemy: 0 = sin pelota 1 = con pelota
;No tocar el de la pelota o puede pasar algo terrible
;Ball var para pelota;
;0 = no lanzada
;1 = Lanzada y choca pared
;Inicializa cosas
;entity_points(iy) = 0 alemania, 1 holanda, 2 francia

game_init::
    ld a, #0xFF
    call render_pant
    call entity_init

    call input_init
    call physics_init
    call render_init

    ld hl, #player
    call entity_create
    ld hl, #enemy
    call entity_create
    ld hl, #ball
    call entity_create
    call animation_init
    
    call entity_getBallIY
    ret

game_update::
    call entity_getArrayIX
    call input_update
    call entity_getArrayIX
    call sys_puntuacion_update
    call entity_getArrayIX
    call physics_update
    call entity_getArrayIX
    call animation_update
    call entity_getArrayIX
    ld de, #sizeof_e ;; Si no es 0, almacenamos el tamaño de la nueva entidad
    add ix, de        
    call animation_update
    ld a, entity_type(iy)
    cp #03
    jr z, ballCogida
    call entity_getArrayIX
    call sys_collision_check
    ballCogida:
        ld a, #03
        cp entity_type(iy)
        jr nz, salto
        call entity_getArrayIX
        call sys_grab_update
    salto:
        call entity_getArrayIX
        ld a, #03
        cp entity_points(ix)
        jr nz, player_gana
        call game_reset_nivel
        call entity_getArrayIX
        call game_reset
        call cpct_akp_stop_asm
        call entity_getArrayIX
        call render_pant2
        call render_pant ;;ESTE ES BASTANTE INCOMODO
        call render_init
        ld de, #_song_ingame2
        call cpct_akp_musicInit_asm
        jp acaba
    player_gana:
        ld de, #sizeof_e
        add ix, de
        ld a, #03
        cp entity_points(ix)
        jr nz, acaba
        call entity_getArrayIX
        call game_pasa_nivel
        call game_reset
        call cpct_akp_stop_asm
            ld a, entity_points(iy)
            cp #03
            jr nz, jump
            call entity_getArrayIX
            call game_reset_nivel
            call render_pant4
            call render_pant
            call render_init
            ld de, #_song_ingame2
            call cpct_akp_musicInit_asm
            jr acaba
        jump:
        call entity_getArrayIX
        call render_pant3
        call render_init
        ld a, entity_points(iy)
        cp #01
        jr nz, aca
        ld de, #_song_ingame
        call cpct_akp_musicInit_asm
        aca:
        ld a, entity_points(iy)
        cp #02
        jr nz, acaba
        ld de, #_song_ingame3
        call cpct_akp_musicInit_asm
    ;Llamar metodo en funcion de la pelota
    ;Y llamar al follow de la misma forma
    acaba:
    ret

game_render::
    call entity_getArrayIX
    call render_update
    ret

game_reset::
    ld entity_x(ix), #0x24
    ld entity_y(ix), #0xA4
    ld entity_points(ix), #0

    ld de, #sizeof_e ;; Si no es 0, almacenamos el tamaño de la nueva entidad
    add ix, de

    ld entity_x(ix), #0x24
    ld entity_y(ix), #0x11
    ld entity_vx(ix), #1
    ld entity_vy(ix), #2
    ld entity_points(ix), #0

    ld entity_x(iy), #0x26
    ld entity_y(iy), #0x60
    ld entity_vx(iy), #0
    ld entity_vy(iy), #01
    ld entity_ball(iy), #15
    
    ret

game_pasa_nivel::
    ld a, entity_points(iy)
    add #01
    ld entity_points(iy), a
    ret

game_reset_nivel::
    ld entity_points(iy), #0
    ret