;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "lib/man/entity.h.s"
.include "lib/assets/assets.h.s"
.include "lib/cpct_functions.h.s"
.include "lib/man/animations.h.s"

.module animation
animation_init::
    ret

animation_update::
    _entity_pend = . +1
    ld hl, #0x0000
    
    _update_loop:
    ;control de estados de animacion
    call calculateAnimStatus
    ;ya tenemos el estado en b
    ;comprobamos si el estado de la animacion es el mismo que el de antes
    ld a, entity_anim_status(ix) ;cargar el estado de la animacion
    cp b ;cp hace una resta sin modificar el registro a
    jr z, _continueAnim

    _newAnimationStatus:
        ld entity_anim_status(ix), b ;cambio al nuevo estado de animacion
        ex de, hl
        call man_animationHL
        ld entity_anim_l(ix), l ;almaceno el siguiente frame de la animacion
        ld entity_anim_h(ix), h
        ex de, hl
    _continueAnim:
        ld l, entity_anim_l(ix) ; HL es el frame actual de la animacion
        ld h, entity_anim_h(ix)
        _return2anim:
            ;en la parte baja del registro bc, cargo el primer byte (CON PARENTESIS),el incremento es para apuntar al siguiente byte cuando le toque a b
            ld c, (hl) ;BC = siguiente frame en la animacion 
            inc hl
            ld b, (hl)

            inc hl ;para apuntar al siguiente byte, que seria la parte baja del siguiente puntero a sprite del array de punteros a sprite que compone la animacion

            ld a, c     ;carga c en a y hacer un or con b para compronar si el resultado es 00 00. De ser asi, hacemos un salto al reset de la animacion
            or b      ;cuando pilla el nullpointer la resetea
            jr z, _resetAnim

            ld entity_anim_l(ix), l ;almaceno el siguiente frame de la animacion
            ld entity_anim_h(ix), h
            
            ;cambiar el puntero a sprite
            ld entity_spriteL(ix), c ;#<_sp_playerDrcha ;c;#< llamar a la parte baja del puntero a sprite 
            ld entity_spriteH(ix), b ;#>_sp_playerDrcha ; b #> llamar a la parte alta del puntero a sprite
            
            ;; Y repetimos
            ret
        _resetAnim:
                ;cargar en hl a lo que apunta hl
                ld a, (hl) ;cargo en a la parte baja del puntero
                inc hl
                ld h, (hl) ;hl apunta al inicio de la animacion, cargo en h la parte alta del puntero
                ld l, a ;cargo en l la parte baja para tener el puntero en hl
                jr _return2anim
                ret
    
    ret
calculateAnimStatus:
    ld b, #0 ;cargo en b el estado base
    ld a, entity_type(ix) ;cargo el componente de entidad para ver si es el enemigo
    and #0x01
    jr z, _isplayer
    _isEnemy:
        ld b, #0x10
    _isplayer:
        ld a, entity_vx(ix) ; empezamos cargando la velocidad
        or a
        jr z, _vxzero ;compruebo si es 0
    _vxnozero:
        jp m, _vxnegative ;si es negativo salto al trozo de codigo que tratara el negativo
    _vxpositive:
        set 0, b 
        jr _vxzero
    _vxnegative:
        set 1, b
    _vxzero:
        
        ;PARA EL EJE Y
    ld a, entity_vy(ix) ; empezamos cargando la velocidad
    or a
    jr z, _vyzero ;compruebo si es 0
    _vynozero:
        jp m, _vynegative ;si es negativo salto al trozo de codigo que tratara el negativo
    _vypositive:
        set 2, b 
        jr _vyzero
    _vynegative:
        set 3, b
    _vyzero:
        
    ret