;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;; Collision system
;;

.include "lib/sys/collision.h.s"
.include "lib/man/entity.h.s"
.include "lib/sys/grab.h.s"

;; IX entidad 1
;; IY entidad 2
sys_collision_check::
    ;; if (A<B) No choca
    ;; if (e_x(ix) + e_w(ix) < e_x(iy)) No choca
    ;;if (e_x(ix) + e_w(ix) - e_x(iy) <0) No choca

    ld b, #2
    
_loop:
    ;; if (C<D) No choca
    ;; if (e_x(iy) + e_w(iy) < e_x(ix)) No choca
    ;; if (e_x(iy) + e_w(iy) - e_x(ix) <0) No choca

    ld a, entity_x(ix)
    add entity_w(ix)
    cp entity_x(iy)
    jr c, _no_collision
 
    ld a, entity_x(iy)
    add entity_w(iy)
    cp entity_x(ix)
    jr c, _no_collision

    ld a, entity_y(ix)
    add entity_h(ix)
    cp entity_y(iy)
    jr c, _no_collision
 
    ld a, entity_y(iy)
    add entity_h(iy)
    cp entity_y(ix)
    jr c, _no_collision

    ;Pruebas
    
    ;DETECTA COLISION
    ;AQUI LLAMAMOS AL METODO QUE HAGA FALTA
    ;Guardar previamente en iy la pelota
    ;Guardar en ix primero player y luego enemigo
    
    ;To do
    ;Al colisionar, la pelota se transporta a 
    ;el centro del sprite que la tenga
    ;Agunata la velocidad del sprite que la tenga
    ;Pulsas boton y la pelota pilla la
    ;velocidad del lanzador
   
    ld entity_type(iy), #0x03
    ld entity_ball(ix), #0x01
    ;call sys_grab_update

    xor a
    cp entity_type(ix)
    jr z, esPlayer
    ld entity_ball(iy), #15
    jr reduc

    esPlayer:
        ld entity_ball(iy), #0x50
        jr reduc
    
_no_collision:

    reduc:
    dec b ;; Decrementamos el numero de entidades
    ret z ;; Si el numero de entidades es 0, terminamos

    ld de, #sizeof_e ;; Si no es 0, almacenamos el tamaño de la nueva entidad
    add ix, de
    jr _loop ;; Y repetimos