;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;; Sistema de agarre y lanzamiento de balón
;;
;; Recibe en IY la pelota y en IX quien la tenga
.include "lib/sys/grab.h.s"
.include "lib/man/entity.h.s"
.include "lib/cpct_functions.h.s"


sys_grab_update::
    ;Se coloca delante del jugador
    ;Comprueba quien tiene la pelota, si el enemigo
    ;o el player
    xor a
    cp entity_ball(ix)
    jr nz, entra

    ld de, #sizeof_e
    add ix, de

    entra:
    ld a, entity_x(ix)
    ld entity_x(iy), a

    ;Debe comprobar si es el enemigo o el player
    ;Para poner la pelota en un lugar u otro
    xor a
    cp entity_type(ix)
    jr z, salto
        ld a, entity_y(ix)
        add entity_h(ix)
        jr ya
    salto:
        ld a, entity_y(ix)
        sub entity_h(iy)
    ya:
    ld entity_y(iy), a
    ld entity_vy(ix), #02

    ;; Comprobamos si es un enemigo o player, para saber cuando debe lanzar
    xor a
    cp entity_type(ix)
    jr z, espacio

    ;; Es un enemigo, comprobamos si debe tirar
    dec entity_ball(iy)
    cp entity_ball(iy)
    jr z, lanzamiento_enemy
    jr nz, no_lanza

espacio: ;; Es player, si pulsa espacio tira
    call cpct_scanKeyboard_f_asm
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr nz, lanzamiento
    ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm
    jr nz, lanzamiento
    dec entity_ball(iy)
    cp entity_ball(iy)
    jr z, lanzamiento_mal ;; Si el jugador no tira en 3 segundos, tira mal
    jr nz, no_lanza

    lanzamiento_mal:
        ld entity_vy(iy), #-1
        ld entity_vx(iy), #0
        ld entity_type(iy), #02
        ld entity_ball(ix), #0
        jr no_lanza

    lanzamiento_enemy:
        jr saltico

    lanzamiento:
        ;Al lanzar poner variables al origen
        saltico:
        ld entity_type(iy), #02
        ld entity_ball(ix), #0
        ld a, entity_vx(ix)
        ld entity_vx(iy), a
        ld a, entity_y(ix)
        cp #0x61
        jr c, lanza_abajo
        
        ld a, entity_vx(ix)
        cp #0
        jr nz, no_suma
            ld entity_vy(iy), #-3
            jr no_lanza
        no_suma:
            ld entity_vy(iy), #-2
        jr no_lanza
    lanza_abajo:
        ld a, entity_vx(ix)
        cp #0
        jr nz, no_suma2
            ld entity_vy(iy), #3
            jr no_lanza
        no_suma2:
            ld entity_vy(iy), #2
        jr no_lanza
    no_lanza:

    ret

