;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;.include "cpctelera.h.s"
.include "lib/man/entity.h.s"
.include "lib/cpct_functions.h.s"
.include "lib/sys/input.h.s"

input_init::
    ret

input_update::
    ld entity_vx(ix), #0
    ld entity_vy(ix), #0

    call cpct_scanKeyboard_f_asm

    ld hl, #Key_O
    call cpct_isKeyPressed_asm
    jr nz, O_Pressed
    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm
    jr nz, O_Pressed

O_NotPressed:
    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr nz, P_Pressed
    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm
    jr nz, P_Pressed
    jr P_NotPressed
O_Pressed:
    ld entity_vx(ix), #-1
    jr P_NotPressed
P_Pressed:
    ld entity_vx(ix), #1
P_NotPressed:
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr nz, Q_Pressed
    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm
    jr nz, Q_Pressed
Q_NotPressed:
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr nz, A_Pressed
    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm
    jr nz, A_Pressed
    jr A_NotPressed
Q_Pressed:
    ld entity_vy(ix), #-2
    jr A_NotPressed
A_Pressed:
    ld entity_vy(ix), #2
A_NotPressed:
    ret

;input_update::
;    ld entity_vx(ix), #0
;    ld entity_vy(ix), #0
;
;    call cpct_scanKeyboard_f_asm
;
;    ld hl, #Key_O
;    call cpct_isKeyPressed_asm
;    jr z, O_NotPressed
;O_Pressed:
;    ld entity_vx(ix), #-1
;O_NotPressed:
;    ld hl, #Key_P 
;    call cpct_isKeyPressed_asm
;    jr z, P_NotPressed
;P_Pressed:
;    ld entity_vx(ix), #1
;P_NotPressed:
;    ld hl, #Key_Q
;    call cpct_isKeyPressed_asm
;    jr z, Q_NotPressed
;Q_Pressed:
;    ld entity_vy(ix), #-2
;Q_NotPressed:
;    ld hl, #Key_A 
;    call cpct_isKeyPressed_asm
;    jr z, A_NotPressed
;A_Pressed:
;    ld entity_vy(ix), #2
;A_NotPressed:
;    ret
;