;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Disc Respect, An Amstrad CPC Game 
;;  Copyright (C) 2019 
;;  Made with CPCtelera: An Amstrad CPC Game Engine
;;  Sergio Sebastián: ssebasa98@gmail.com
;;  Roque Bru: elroquemadridista@gmail.com
;;  Sergio Campos: okicampos@gmail.com
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.include "lib/sys/puntuacion.h.s"
.include "lib/man/entity.h.s"
.include "lib/sys/render.h.s"

screen_height=200
sys_puntuacion_init::
    ld de, #sizeof_e
    ld entity_points(ix), #00
    add ix, de
    ld entity_points(ix), #00
    ret

sys_puntuacion_update::
;Colisiona la pelota con un marco
;Comprueba su velocidad para saber quien la lanza
;Aumenta el marcador
;Pone la variable de la pelota con un valor para ver
;desde donde toca que se saque
    ld de, #sizeof_e
    ld a, #screen_height - 9;; Metemos en a el ancho de la pantalla mas 1
    sub entity_h(iy) ;; Le restamos el ancho de la entidad
    ld c, a ;; Lo guardamos en c

    ld a, entity_y(iy) ;; Guardamos en a la posicion x
    add entity_vy(iy) ;; Y le sumamos la velocidad
    cp c ;; A - C
    jr nc, invalid_y_abajo ;; Si te sales de la pantalla (la resta da menos de 0) va a invalid_x

    ld a, entity_y(iy)
    add entity_vy(iy)
    cp #0x10
    jr c, invalid_y_arriba
    jr end

invalid_y_abajo:
    ld entity_y(iy), #160
    jr endif_y
invalid_y_arriba:
    add ix, de
    ld entity_y(iy), #40
endif_y:
    ld entity_x(iy), #38
    ld entity_vy(iy), #00
    ld entity_vx(iy), #00
    ld a, entity_points(ix)
    inc a
    ld entity_points(ix), a
    call render_punto
end:
    ret